package com.google.android.gms.common.api.internal;

import android.app.Application;
import android.app.PendingIntent;
import android.content.Context;
import android.os.Handler;
import android.os.Handler.Callback;
import android.os.HandlerThread;
import android.os.Looper;
import android.os.Message;
import android.support.annotation.NonNull;
import android.support.annotation.WorkerThread;
import android.support.v4.util.ArraySet;
import android.util.Log;
import com.google.android.gms.common.ConnectionResult;
import com.google.android.gms.common.GoogleApiAvailability;
import com.google.android.gms.common.api.Api.ApiOptions;
import com.google.android.gms.common.api.Api.zzb;
import com.google.android.gms.common.api.Api.zze;
import com.google.android.gms.common.api.GoogleApi;
import com.google.android.gms.common.api.Result;
import com.google.android.gms.common.api.Status;
import com.google.android.gms.common.internal.Hide;
import com.google.android.gms.common.internal.zzbq;
import com.google.android.gms.internal.zzcyj;
import com.google.android.gms.tasks.Task;
import com.google.android.gms.tasks.TaskCompletionSource;
import java.util.Collection;
import java.util.Iterator;
import java.util.Map;
import java.util.Set;
import java.util.concurrent.ConcurrentHashMap;
import java.util.concurrent.atomic.AtomicInteger;

@Hide
public final class zzbm
  implements Handler.Callback
{
  public static final Status zzfzg = new Status(4, "Sign-out occurred while this API call was in progress.");
  private static final Status zzfzh = new Status(4, "The user must be signed in to make this API call.");
  private long zzfyg = 5000L;
  private long zzfyf = 120000L;
  private long zzfzi = 10000L;
  private static final Object sLock = new Object();
  private static zzbm zzfzj;
  private final Context mContext;
  private final GoogleApiAvailability zzftg;
  private int zzfzk = -1;
  private final AtomicInteger zzfzl = new AtomicInteger(1);
  private final AtomicInteger zzfzm = new AtomicInteger(0);
  private final Map<zzh<?>, zzbo<?>> zzfwg = new ConcurrentHashMap(5, 0.75F, 1);
  private zzah zzfzn = null;
  private final Set<zzh<?>> zzfzo = new ArraySet();
  private final Set<zzh<?>> zzfzp = new ArraySet();
  private final Handler mHandler;
  
  public static zzbm zzck(Context paramContext)
  {
    synchronized (sLock)
    {
      if (zzfzj == null)
      {
        HandlerThread localHandlerThread;
        (localHandlerThread = new HandlerThread("GoogleApiHandler", 9)).start();
        Looper localLooper = localHandlerThread.getLooper();
        zzfzj = new zzbm(paramContext.getApplicationContext(), localLooper, GoogleApiAvailability.getInstance());
      }
      return zzfzj;
    }
  }
  
  public static zzbm zzajy()
  {
    synchronized (sLock)
    {
      zzbq.checkNotNull(zzfzj, "Must guarantee manager is non-null before using getInstance");
      return zzfzj;
    }
  }
  
  public static void zzajz()
  {
    synchronized (sLock)
    {
      if (zzfzj != null)
      {
        zzbm localzzbm;
        (localzzbm = zzfzj).zzfzm.incrementAndGet();
        localzzbm.mHandler.sendMessageAtFrontOfQueue(localzzbm.mHandler.obtainMessage(10));
      }
      return;
    }
  }
  
  private zzbm(Context paramContext, Looper paramLooper, GoogleApiAvailability paramGoogleApiAvailability)
  {
    this.mContext = paramContext;
    this.mHandler = new Handler(paramLooper, this);
    this.zzftg = paramGoogleApiAvailability;
    this.mHandler.sendMessage(this.mHandler.obtainMessage(6));
  }
  
  public final int zzaka()
  {
    return this.zzfzl.getAndIncrement();
  }
  
  public final void zza(GoogleApi<?> paramGoogleApi)
  {
    this.mHandler.sendMessage(this.mHandler.obtainMessage(7, paramGoogleApi));
  }
  
  @WorkerThread
  private final void zzb(GoogleApi<?> paramGoogleApi)
  {
    zzh localzzh = paramGoogleApi.zzahv();
    zzbo localzzbo;
    if ((localzzbo = (zzbo)this.zzfwg.get(localzzh)) == null)
    {
      localzzbo = new zzbo(this, paramGoogleApi);
      this.zzfwg.put(localzzh, localzzbo);
    }
    if (localzzbo.zzacc()) {
      this.zzfzp.add(localzzh);
    }
    localzzbo.connect();
  }
  
  public final void zza(@NonNull zzah paramzzah)
  {
    synchronized (sLock)
    {
      if (this.zzfzn != paramzzah)
      {
        this.zzfzn = paramzzah;
        this.zzfzo.clear();
        this.zzfzo.addAll(paramzzah.zzajf());
      }
      return;
    }
  }
  
  final void zzb(@NonNull zzah paramzzah)
  {
    synchronized (sLock)
    {
      if (this.zzfzn == paramzzah)
      {
        this.zzfzn = null;
        this.zzfzo.clear();
      }
      return;
    }
  }
  
  public final Task<Map<zzh<?>, String>> zza(Iterable<? extends GoogleApi<?>> paramIterable)
  {
    zzj localzzj = new zzj(paramIterable);
    Iterator localIterator = paramIterable.iterator();
    while (localIterator.hasNext())
    {
      GoogleApi localGoogleApi = (GoogleApi)localIterator.next();
      zzbo localzzbo;
      if (((localzzbo = (zzbo)this.zzfwg.get(localGoogleApi.zzahv())) == null) || (!localzzbo.isConnected()))
      {
        this.mHandler.sendMessage(this.mHandler.obtainMessage(2, localzzj));
        return localzzj.getTask();
      }
      localzzj.zza(localGoogleApi.zzahv(), ConnectionResult.zzfqt, localzzbo.zzaix().zzahp());
    }
    return localzzj.getTask();
  }
  
  public final void zzaih()
  {
    this.mHandler.sendMessage(this.mHandler.obtainMessage(3));
  }
  
  final void zzaia()
  {
    this.zzfzm.incrementAndGet();
    this.mHandler.sendMessage(this.mHandler.obtainMessage(10));
  }
  
  @WorkerThread
  private final void zzakb()
  {
    Iterator localIterator = this.zzfzp.iterator();
    while (localIterator.hasNext())
    {
      zzh localzzh = (zzh)localIterator.next();
      ((zzbo)this.zzfwg.remove(localzzh)).signOut();
    }
    this.zzfzp.clear();
  }
  
  public final <O extends Api.ApiOptions> void zza(GoogleApi<O> paramGoogleApi, int paramInt, zzm<? extends Result, Api.zzb> paramzzm)
  {
    zzc localzzc = new zzc(paramInt, paramzzm);
    this.mHandler.sendMessage(this.mHandler.obtainMessage(4, new zzcp(localzzc, this.zzfzm.get(), paramGoogleApi)));
  }
  
  public final <O extends Api.ApiOptions, TResult> void zza(GoogleApi<O> paramGoogleApi, int paramInt, zzde<Api.zzb, TResult> paramzzde, TaskCompletionSource<TResult> paramTaskCompletionSource, zzda paramzzda)
  {
    zze localzze = new zze(paramInt, paramzzde, paramTaskCompletionSource, paramzzda);
    this.mHandler.sendMessage(this.mHandler.obtainMessage(4, new zzcp(localzze, this.zzfzm.get(), paramGoogleApi)));
  }
  
  public final <O extends Api.ApiOptions> Task<Void> zza(@NonNull GoogleApi<O> paramGoogleApi, @NonNull zzcq<Api.zzb, ?> paramzzcq, @NonNull zzdo<Api.zzb, ?> paramzzdo)
  {
    TaskCompletionSource localTaskCompletionSource = new TaskCompletionSource();
    zzd localzzd = new zzd(new zzcr(paramzzcq, paramzzdo), localTaskCompletionSource);
    this.mHandler.sendMessage(this.mHandler.obtainMessage(8, new zzcp(localzzd, this.zzfzm.get(), paramGoogleApi)));
    return localTaskCompletionSource.getTask();
  }
  
  public final <O extends Api.ApiOptions> Task<Boolean> zza(@NonNull GoogleApi<O> paramGoogleApi, @NonNull zzck<?> paramzzck)
  {
    TaskCompletionSource localTaskCompletionSource = new TaskCompletionSource();
    zzf localzzf = new zzf(paramzzck, localTaskCompletionSource);
    this.mHandler.sendMessage(this.mHandler.obtainMessage(13, new zzcp(localzzf, this.zzfzm.get(), paramGoogleApi)));
    return localTaskCompletionSource.getTask();
  }
  
  @WorkerThread
  public final boolean handleMessage(Message paramMessage)
  {
    zzbm localzzbm;
    Object localObject2;
    Object localObject3;
    Object localObject1;
    Object localObject4;
    Object localObject5;
    switch (paramMessage.what)
    {
    case 1: 
      boolean bool = ((Boolean)paramMessage.obj).booleanValue();
      localzzbm = this;
      this.zzfzi = (bool ? 10000L : 300000L);
      localzzbm.mHandler.removeMessages(12);
      localObject2 = localzzbm.zzfwg.keySet().iterator();
      while (((Iterator)localObject2).hasNext())
      {
        localObject3 = (zzh)((Iterator)localObject2).next();
        localzzbm.mHandler.sendMessageDelayed(localzzbm.mHandler.obtainMessage(12, localObject3), localzzbm.zzfzi);
      }
      break;
    case 2: 
      localObject1 = (zzj)paramMessage.obj;
      localzzbm = this;
      localObject3 = ((zzj)localObject1).zzaii().iterator();
      while (((Iterator)localObject3).hasNext())
      {
        localObject4 = (zzh)((Iterator)localObject3).next();
        if ((localObject5 = (zzbo)localzzbm.zzfwg.get(localObject4)) == null)
        {
          ConnectionResult localConnectionResult = new ConnectionResult(13);
          ((zzj)localObject1).zza((zzh)localObject4, localConnectionResult, null);
          break;
        }
        if (((zzbo)localObject5).isConnected()) {
          ((zzj)localObject1).zza((zzh)localObject4, ConnectionResult.zzfqt, ((zzbo)localObject5).zzaix().zzahp());
        } else if (((zzbo)localObject5).zzakj() != null) {
          ((zzj)localObject1).zza((zzh)localObject4, ((zzbo)localObject5).zzakj(), null);
        } else {
          ((zzbo)localObject5).zza((zzj)localObject1);
        }
      }
      break;
    case 3: 
      localObject1 = this.zzfwg.values().iterator();
      while (((Iterator)localObject1).hasNext())
      {
        (localObject2 = (zzbo)((Iterator)localObject1).next()).zzaki();
        ((zzbo)localObject2).connect();
      }
      break;
    case 4: 
    case 8: 
    case 13: 
      localObject1 = (zzcp)paramMessage.obj;
      localzzbm = this;
      if ((localObject2 = (zzbo)this.zzfwg.get(((zzcp)localObject1).zzgba.zzahv())) == null)
      {
        localzzbm.zzb(((zzcp)localObject1).zzgba);
        localObject2 = (zzbo)localzzbm.zzfwg.get(((zzcp)localObject1).zzgba.zzahv());
      }
      if ((((zzbo)localObject2).zzacc()) && (localzzbm.zzfzm.get() != ((zzcp)localObject1).zzgaz))
      {
        ((zzcp)localObject1).zzgay.zzs(zzfzg);
        ((zzbo)localObject2).signOut();
      }
      else
      {
        ((zzbo)localObject2).zza(((zzcp)localObject1).zzgay);
      }
      break;
    case 5: 
      localObject2 = (ConnectionResult)paramMessage.obj;
      int j = paramMessage.arg1;
      localzzbm = this;
      localObject3 = null;
      localObject4 = localzzbm.zzfwg.values().iterator();
      while (((Iterator)localObject4).hasNext()) {
        if ((localObject5 = (zzbo)((Iterator)localObject4).next()).getInstanceId() == j)
        {
          localObject3 = localObject5;
          break;
        }
      }
      if (localObject3 != null)
      {
        localObject4 = localzzbm.zzftg.getErrorString(((ConnectionResult)localObject2).getErrorCode());
        localObject5 = ((ConnectionResult)localObject2).getErrorMessage();
        ((zzbo)localObject3).zzw(new Status(17, 69 + String.valueOf(localObject4).length() + String.valueOf(localObject5).length() + "Error resolution was canceled by the user, original error message: " + (String)localObject4 + ": " + (String)localObject5));
      }
      else
      {
        Log.wtf("GoogleApiManager", 76 + "Could not find API instance " + j + " while trying to fail enqueued calls.", new Exception());
      }
      break;
    case 6: 
      localzzbm = this;
      if ((this.mContext.getApplicationContext() instanceof Application))
      {
        zzk.zza((Application)localzzbm.mContext.getApplicationContext());
        zzk.zzaij().zza(new zzbn(localzzbm));
        if (!zzk.zzaij().zzbi(true)) {
          localzzbm.zzfzi = 300000L;
        }
      }
      break;
    case 7: 
      zzb((GoogleApi)paramMessage.obj);
      break;
    case 9: 
      if (this.zzfwg.containsKey(paramMessage.obj)) {
        ((zzbo)this.zzfwg.get(paramMessage.obj)).resume();
      }
      break;
    case 10: 
      zzakb();
      break;
    case 11: 
      if (this.zzfwg.containsKey(paramMessage.obj)) {
        ((zzbo)this.zzfwg.get(paramMessage.obj)).zzajr();
      }
      break;
    case 12: 
      if (this.zzfwg.containsKey(paramMessage.obj)) {
        ((zzbo)this.zzfwg.get(paramMessage.obj)).zzakm();
      }
      break;
    default: 
      int i = paramMessage.what;
      Log.w("GoogleApiManager", 31 + "Unknown message id: " + i);
      return false;
    }
    return true;
  }
  
  final PendingIntent zza(zzh<?> paramzzh, int paramInt)
  {
    zzbo localzzbo;
    if ((localzzbo = (zzbo)this.zzfwg.get(paramzzh)) == null) {
      return null;
    }
    zzcyj localzzcyj;
    if ((localzzcyj = localzzbo.zzakn()) == null) {
      return null;
    }
    return PendingIntent.getActivity(this.mContext, paramInt, localzzcyj.getSignInIntent(), 134217728);
  }
  
  final boolean zzc(ConnectionResult paramConnectionResult, int paramInt)
  {
    return this.zzftg.zza(this.mContext, paramConnectionResult, paramInt);
  }
  
  public final void zza(ConnectionResult paramConnectionResult, int paramInt)
  {
    if (!zzc(paramConnectionResult, paramInt)) {
      this.mHandler.sendMessage(this.mHandler.obtainMessage(5, paramInt, 0, paramConnectionResult));
    }
  }
}


/* Location:              C:\Users\nsubhash\Downloads\google-play-services-base.jar!\com\google\android\gms\common\api\internal\zzbm.class
 * Java compiler version: 7 (51.0)
 * JD-Core Version:       0.7.1
 */