package com.google.android.gms.common.api.internal;

import android.os.Bundle;
import android.os.DeadObjectException;
import android.os.Handler;
import android.os.Looper;
import android.os.Message;
import android.os.RemoteException;
import android.support.annotation.NonNull;
import android.support.annotation.Nullable;
import android.support.annotation.WorkerThread;
import com.google.android.gms.common.ConnectionResult;
import com.google.android.gms.common.GoogleApiAvailability;
import com.google.android.gms.common.api.Api;
import com.google.android.gms.common.api.Api.ApiOptions;
import com.google.android.gms.common.api.Api.zzb;
import com.google.android.gms.common.api.Api.zze;
import com.google.android.gms.common.api.GoogleApi;
import com.google.android.gms.common.api.GoogleApiClient.ConnectionCallbacks;
import com.google.android.gms.common.api.GoogleApiClient.OnConnectionFailedListener;
import com.google.android.gms.common.api.Status;
import com.google.android.gms.common.internal.zzbz;
import com.google.android.gms.internal.zzcyj;
import com.google.android.gms.tasks.TaskCompletionSource;
import java.util.Collection;
import java.util.HashMap;
import java.util.HashSet;
import java.util.Iterator;
import java.util.LinkedList;
import java.util.Map;
import java.util.Queue;
import java.util.Set;

public final class zzbo<O extends Api.ApiOptions>
  implements GoogleApiClient.ConnectionCallbacks, GoogleApiClient.OnConnectionFailedListener, zzu
{
  private final Queue<zza> zzfzr = new LinkedList();
  private final Api.zze zzfwd;
  private final Api.zzb zzfzs;
  private final zzh<O> zzfsn;
  private final zzae zzfzt;
  private final Set<zzj> zzfzu = new HashSet();
  private final Map<zzck<?>, zzcr> zzfzv = new HashMap();
  private final int zzfzw;
  private final zzcv zzfzx;
  private boolean zzfye;
  private int zzfzy = -1;
  private ConnectionResult zzfzz = null;
  
  private final void zzake()
  {
    this.zzfzy = -1;
    zzbm.zza(this.zzfzq, -1);
  }
  
  @WorkerThread
  public zzbo(GoogleApi<O> paramGoogleApi)
  {
    Object localObject;
    this.zzfwd = ((GoogleApi)localObject).zza(zzbm.zza(paramGoogleApi).getLooper(), this);
    if ((this.zzfwd instanceof zzbz)) {
      this.zzfzs = zzbz.zzanb();
    } else {
      this.zzfzs = this.zzfwd;
    }
    this.zzfsn = ((GoogleApi)localObject).zzahv();
    this.zzfzt = new zzae();
    this.zzfzw = ((GoogleApi)localObject).getInstanceId();
    if (this.zzfwd.zzacc())
    {
      this.zzfzx = ((GoogleApi)localObject).zza(zzbm.zzc(paramGoogleApi), zzbm.zza(paramGoogleApi));
      return;
    }
    this.zzfzx = null;
  }
  
  public final void onConnected(@Nullable Bundle paramBundle)
  {
    if (Looper.myLooper() == zzbm.zza(this.zzfzq).getLooper())
    {
      zzakf();
      return;
    }
    zzbm.zza(this.zzfzq).post(new zzbp(this));
  }
  
  @WorkerThread
  private final void zzakf()
  {
    zzaki();
    zzi(ConnectionResult.zzfqt);
    zzakk();
    Iterator localIterator = this.zzfzv.values().iterator();
    while (localIterator.hasNext())
    {
      zzcr localzzcr = (zzcr)localIterator.next();
      try
      {
        localzzcr.zzfty.zzb(this.zzfzs, new TaskCompletionSource());
      }
      catch (DeadObjectException localDeadObjectException)
      {
        onConnectionSuspended(1);
        this.zzfwd.disconnect();
        break;
      }
      catch (RemoteException localRemoteException) {}
    }
    zzbo localzzbo = this;
    while ((localzzbo.zzfwd.isConnected()) && (!localzzbo.zzfzr.isEmpty()))
    {
      zza localzza = (zza)localzzbo.zzfzr.remove();
      localzzbo.zzb(localzza);
    }
    zzakl();
  }
  
  public final void onConnectionSuspended(int paramInt)
  {
    if (Looper.myLooper() == zzbm.zza(this.zzfzq).getLooper())
    {
      zzakg();
      return;
    }
    zzbm.zza(this.zzfzq).post(new zzbq(this));
  }
  
  @WorkerThread
  private final void zzakg()
  {
    zzaki();
    this.zzfye = true;
    this.zzfzt.zzaje();
    zzbm.zza(this.zzfzq).sendMessageDelayed(Message.obtain(zzbm.zza(this.zzfzq), 9, this.zzfsn), zzbm.zzd(this.zzfzq));
    zzbm.zza(this.zzfzq).sendMessageDelayed(Message.obtain(zzbm.zza(this.zzfzq), 11, this.zzfsn), zzbm.zze(this.zzfzq));
    zzake();
  }
  
  @WorkerThread
  public final void zzh(@NonNull ConnectionResult paramConnectionResult)
  {
    com.google.android.gms.common.internal.zzbq.zza(zzbm.zza(this.zzfzq));
    this.zzfwd.disconnect();
    onConnectionFailed(paramConnectionResult);
  }
  
  public final void zza(ConnectionResult paramConnectionResult, Api<?> paramApi, boolean paramBoolean)
  {
    if (Looper.myLooper() == zzbm.zza(this.zzfzq).getLooper())
    {
      onConnectionFailed(paramConnectionResult);
      return;
    }
    zzbm.zza(this.zzfzq).post(new zzbr(this, paramConnectionResult));
  }
  
  @WorkerThread
  public final void onConnectionFailed(@NonNull ConnectionResult paramConnectionResult)
  {
    com.google.android.gms.common.internal.zzbq.zza(zzbm.zza(this.zzfzq));
    if (this.zzfzx != null) {
      this.zzfzx.zzakz();
    }
    zzaki();
    zzake();
    zzi(paramConnectionResult);
    if (paramConnectionResult.getErrorCode() == 4)
    {
      zzw(zzbm.zzakc());
      return;
    }
    if (this.zzfzr.isEmpty())
    {
      this.zzfzz = paramConnectionResult;
      return;
    }
    synchronized (zzbm.zzakd())
    {
      if ((zzbm.zzf(this.zzfzq) != null) && (zzbm.zzg(this.zzfzq).contains(this.zzfsn)))
      {
        zzbm.zzf(this.zzfzq).zzb(paramConnectionResult, this.zzfzw);
        return;
      }
    }
    if (!this.zzfzq.zzc(paramConnectionResult, this.zzfzw))
    {
      if (paramConnectionResult.getErrorCode() == 18) {
        this.zzfye = true;
      }
      if (this.zzfye)
      {
        zzbm.zza(this.zzfzq).sendMessageDelayed(Message.obtain(zzbm.zza(this.zzfzq), 9, this.zzfsn), zzbm.zzd(this.zzfzq));
        return;
      }
      ??? = this.zzfsn.zzaig();
      zzw(new Status(17, 38 + String.valueOf(???).length() + "API: " + (String)??? + " is not available on this device."));
    }
  }
  
  @WorkerThread
  public final void zza(zza paramzza)
  {
    com.google.android.gms.common.internal.zzbq.zza(zzbm.zza(this.zzfzq));
    if (this.zzfwd.isConnected())
    {
      zzb(paramzza);
      zzakl();
      return;
    }
    this.zzfzr.add(paramzza);
    if ((this.zzfzz != null) && (this.zzfzz.hasResolution()))
    {
      onConnectionFailed(this.zzfzz);
      return;
    }
    connect();
  }
  
  @WorkerThread
  public final void signOut()
  {
    com.google.android.gms.common.internal.zzbq.zza(zzbm.zza(this.zzfzq));
    zzw(zzbm.zzfzg);
    this.zzfzt.zzajd();
    zzck[] arrayOfzzck;
    int i = (arrayOfzzck = (zzck[])this.zzfzv.keySet().toArray(new zzck[this.zzfzv.size()])).length;
    for (int j = 0; j < i; j++)
    {
      zzck localzzck = arrayOfzzck[j];
      zza(new zzf(localzzck, new TaskCompletionSource()));
    }
    zzi(new ConnectionResult(4));
    if (this.zzfwd.isConnected()) {
      this.zzfwd.zza(new zzbs(this));
    }
  }
  
  public final Api.zze zzaix()
  {
    return this.zzfwd;
  }
  
  public final Map<zzck<?>, zzcr> zzakh()
  {
    return this.zzfzv;
  }
  
  @WorkerThread
  public final void zzaki()
  {
    com.google.android.gms.common.internal.zzbq.zza(zzbm.zza(this.zzfzq));
    this.zzfzz = null;
  }
  
  @WorkerThread
  public final ConnectionResult zzakj()
  {
    com.google.android.gms.common.internal.zzbq.zza(zzbm.zza(this.zzfzq));
    return this.zzfzz;
  }
  
  @WorkerThread
  private final void zzb(zza paramzza)
  {
    paramzza.zza(this.zzfzt, zzacc());
    try
    {
      paramzza.zza(this);
      return;
    }
    catch (DeadObjectException localDeadObjectException)
    {
      onConnectionSuspended(1);
      this.zzfwd.disconnect();
    }
  }
  
  @WorkerThread
  public final void zzw(Status paramStatus)
  {
    com.google.android.gms.common.internal.zzbq.zza(zzbm.zza(this.zzfzq));
    Iterator localIterator = this.zzfzr.iterator();
    while (localIterator.hasNext()) {
      ((zza)localIterator.next()).zzs(paramStatus);
    }
    this.zzfzr.clear();
  }
  
  @WorkerThread
  public final void resume()
  {
    com.google.android.gms.common.internal.zzbq.zza(zzbm.zza(this.zzfzq));
    if (this.zzfye) {
      connect();
    }
  }
  
  @WorkerThread
  private final void zzakk()
  {
    if (this.zzfye)
    {
      zzbm.zza(this.zzfzq).removeMessages(11, this.zzfsn);
      zzbm.zza(this.zzfzq).removeMessages(9, this.zzfsn);
      this.zzfye = false;
    }
  }
  
  @WorkerThread
  public final void zzajr()
  {
    com.google.android.gms.common.internal.zzbq.zza(zzbm.zza(this.zzfzq));
    if (this.zzfye)
    {
      zzakk();
      Status localStatus;
      if (zzbm.zzh(this.zzfzq).isGooglePlayServicesAvailable(zzbm.zzc(this.zzfzq)) == 18) {
        localStatus = new Status(8, "Connection timed out while waiting for Google Play services update to complete.");
      } else {
        localStatus = new Status(8, "API failed to connect while resuming due to an unknown error.");
      }
      zzw(localStatus);
      this.zzfwd.disconnect();
    }
  }
  
  private final void zzakl()
  {
    zzbm.zza(this.zzfzq).removeMessages(12, this.zzfsn);
    zzbm.zza(this.zzfzq).sendMessageDelayed(zzbm.zza(this.zzfzq).obtainMessage(12, this.zzfsn), zzbm.zzi(this.zzfzq));
  }
  
  @WorkerThread
  public final void zzakm()
  {
    com.google.android.gms.common.internal.zzbq.zza(zzbm.zza(this.zzfzq));
    if ((this.zzfwd.isConnected()) && (this.zzfzv.size() == 0))
    {
      if (this.zzfzt.zzajc())
      {
        zzakl();
        return;
      }
      this.zzfwd.disconnect();
    }
  }
  
  @WorkerThread
  public final void connect()
  {
    com.google.android.gms.common.internal.zzbq.zza(zzbm.zza(this.zzfzq));
    if ((this.zzfwd.isConnected()) || (this.zzfwd.isConnecting())) {
      return;
    }
    if (this.zzfwd.zzahn())
    {
      zzbo localzzbo = this;
      this.zzfwd.zzahq();
      if (zzbm.zzb(localzzbo.zzfzq) != 0)
      {
        zzbm.zzh(this.zzfzq);
        int i = GoogleApiAvailability.zzc(zzbm.zzc(this.zzfzq), this.zzfwd.zzahq());
        int j = i;
        localzzbo = this;
        this.zzfwd.zzahq();
        zzbm.zza(localzzbo.zzfzq, j);
        if (i != 0)
        {
          ConnectionResult localConnectionResult = new ConnectionResult(i, null);
          onConnectionFailed(localConnectionResult);
          return;
        }
      }
    }
    zzbu localzzbu = new zzbu(this.zzfzq, this.zzfwd, this.zzfsn);
    if (this.zzfwd.zzacc()) {
      this.zzfzx.zza(localzzbu);
    }
    this.zzfwd.zza(localzzbu);
  }
  
  @WorkerThread
  public final void zza(zzj paramzzj)
  {
    com.google.android.gms.common.internal.zzbq.zza(zzbm.zza(this.zzfzq));
    this.zzfzu.add(paramzzj);
  }
  
  @WorkerThread
  private final void zzi(ConnectionResult paramConnectionResult)
  {
    Iterator localIterator = this.zzfzu.iterator();
    while (localIterator.hasNext())
    {
      zzj localzzj = (zzj)localIterator.next();
      String str = null;
      if (paramConnectionResult == ConnectionResult.zzfqt) {
        str = this.zzfwd.zzahp();
      }
      localzzj.zza(this.zzfsn, paramConnectionResult, str);
    }
    this.zzfzu.clear();
  }
  
  final boolean isConnected()
  {
    return this.zzfwd.isConnected();
  }
  
  public final boolean zzacc()
  {
    return this.zzfwd.zzacc();
  }
  
  public final int getInstanceId()
  {
    return this.zzfzw;
  }
  
  final zzcyj zzakn()
  {
    if (this.zzfzx == null) {
      return null;
    }
    return this.zzfzx.zzakn();
  }
}


/* Location:              C:\Users\nsubhash\Downloads\google-play-services-base.jar!\com\google\android\gms\common\api\internal\zzbo.class
 * Java compiler version: 7 (51.0)
 * JD-Core Version:       0.7.1
 */