package com.google.android.gms.common.api.internal;

import android.os.DeadObjectException;
import android.os.RemoteException;
import android.support.annotation.NonNull;
import com.google.android.gms.common.api.Api;
import com.google.android.gms.common.api.Api.zzb;
import com.google.android.gms.common.api.Api.zzc;
import com.google.android.gms.common.api.GoogleApiClient;
import com.google.android.gms.common.api.Result;
import com.google.android.gms.common.api.Status;
import com.google.android.gms.common.internal.Hide;
import com.google.android.gms.common.internal.zzbq;
import com.google.android.gms.common.internal.zzbz;

public abstract class zzm<R extends Result, A extends Api.zzb>
  extends BasePendingResult<R>
  implements zzn<R>
{
  private final Api.zzc<A> zzfus;
  private final Api<?> zzfop;
  
  @Deprecated
  protected zzm(@NonNull Api.zzc<A> paramzzc, @NonNull GoogleApiClient paramGoogleApiClient)
  {
    super((GoogleApiClient)zzbq.checkNotNull(paramGoogleApiClient, "GoogleApiClient must not be null"));
    this.zzfus = ((Api.zzc)zzbq.checkNotNull(paramzzc));
    this.zzfop = null;
  }
  
  protected zzm(@NonNull Api<?> paramApi, @NonNull GoogleApiClient paramGoogleApiClient)
  {
    super((GoogleApiClient)zzbq.checkNotNull(paramGoogleApiClient, "GoogleApiClient must not be null"));
    zzbq.checkNotNull(paramApi, "Api must not be null");
    this.zzfus = paramApi.zzahm();
    this.zzfop = paramApi;
  }
  
  @Hide
  public final Api.zzc<A> zzahm()
  {
    return this.zzfus;
  }
  
  @Hide
  public final Api<?> zzaht()
  {
    return this.zzfop;
  }
  
  @Hide
  public final void zzb(@NonNull A paramA)
    throws DeadObjectException
  {
    if ((paramA instanceof zzbz)) {
      paramA = zzbz.zzanb();
    }
    try
    {
      zza(paramA);
      return;
    }
    catch (DeadObjectException localDeadObjectException)
    {
      zzc(localDeadObjectException);
      throw localDeadObjectException;
    }
    catch (RemoteException localRemoteException)
    {
      zzc(localRemoteException);
    }
  }
  
  @Hide
  public final void zzu(@NonNull Status paramStatus)
  {
    zzbq.checkArgument(!paramStatus.isSuccess(), "Failed result must not be success");
    Result localResult = zzb(paramStatus);
    setResult(localResult);
  }
  
  @Hide
  protected abstract void zza(@NonNull A paramA)
    throws RemoteException;
  
  private final void zzc(@NonNull RemoteException paramRemoteException)
  {
    Status localStatus = new Status(8, paramRemoteException.getLocalizedMessage(), null);
    zzu(localStatus);
  }
}


/* Location:              C:\Users\nsubhash\Downloads\google-play-services-base.jar!\com\google\android\gms\common\api\internal\zzm.class
 * Java compiler version: 7 (51.0)
 * JD-Core Version:       0.7.1
 */